<?php

namespace Drupal\eca\Plugin\Action;

/**
 * Interface for ECA provided actions.
 */
interface ActionInterface {

  /**
   * Sets the triggered event that leads to this action.
   *
   * @param \Drupal\Component\EventDispatcher\Event|\Symfony\Contracts\EventDispatcher\Event $event
   *   The triggered event.
   *
   * @return $this
   */
  public function setEvent(object $event): ActionInterface;

  /**
   * Get the triggered event that leads to this action.
   *
   * @return \Drupal\Component\EventDispatcher\Event|\Symfony\Contracts\EventDispatcher\Event
   *   The trigered event.
   */
  public function getEvent(): object;

  /**
   * Gets default configuration for this plugin.
   *
   * @return array
   *   An associative array with the default configuration.
   */
  public function defaultConfiguration(): array;

}
